DROP TABLE IMRD_F.EN_MRD098_H6 CASCADE CONSTRAINTS;

--criando a tabela com a PK ID
CREATE TABLE IMRD_F.EN_MRD098_H6
(
    NM_CD_2303          VARCHAR2(2048 BYTE),
    APPLB_KEY_CD_0103   VARCHAR2(2048 BYTE),
    DT_ESTB_CANC_0308   VARCHAR2(2048 BYTE),
    STA_CD_NM_FSC_0320  VARCHAR2(2048 BYTE),
    SHRT_NM_2301        VARCHAR2(2048 BYTE),
    NM_PREFIX_2516      VARCHAR2(2048 BYTE),
    NM_ROOT_RMDR_2517   VARCHAR2(2048 BYTE),
    FSC_COND_CD_2607    VARCHAR2(2048 BYTE),
    ITM_NM_TYP_CD_3308  VARCHAR2(2048 BYTE),
    FIIG_4065           VARCHAR2(2048 BYTE),
    CONCEPT_NBR_4488    VARCHAR2(2048 BYTE),
    ITM_NM_DEF_5015     VARCHAR2(2048 BYTE),
    ID                  NUMBER(19),
    PRIMARY KEY(ID)
)
TABLESPACE IMRD_FTBL
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

--criando os sinonimos publicos
CREATE OR REPLACE PUBLIC SYNONYM EN_MRD098_H6 FOR IMRD_F.EN_MRD098_H6;

--dropando a sequence
DROP SEQUENCE IMRD_F.SQ_EN_TABL098;

--criando a sequence
CREATE SEQUENCE IMRD_F.SQ_EN_TABL098
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 0
  NOCYCLE
  NOCACHE
  NOORDER;

--criando indices
CREATE UNIQUE INDEX IDX_EN_MRD098_H6_INC ON IMRD_F.EN_MRD098_H6(NM_CD_2303) TABLESPACE IMRD_FTBL; 

-----------------------FIM----------------------
DROP TABLE IMRD_F.EN_MRD_H6 CASCADE CONSTRAINTS;

--criando a tabela com a PK ID
CREATE TABLE IMRD_F.EN_MRD_H6
(
    NM_CD_2303          VARCHAR2(2048 BYTE),
    APPLB_KEY_CD_0103   VARCHAR2(2048 BYTE),
    DT_ESTB_CANC_0308   VARCHAR2(2048 BYTE),
    STA_CD_NM_FSC_0320  VARCHAR2(2048 BYTE),
    SHRT_NM_2301        VARCHAR2(2048 BYTE),
    NM_PREFIX_2516      VARCHAR2(2048 BYTE),
    NM_ROOT_RMDR_2517   VARCHAR2(2048 BYTE),
    FSC_COND_CD_2607    VARCHAR2(2048 BYTE),
    ITM_NM_TYP_CD_3308  VARCHAR2(2048 BYTE),
    FIIG_4065           VARCHAR2(2048 BYTE),
    CONCEPT_NBR_4488    VARCHAR2(2048 BYTE),
    ITM_NM_DEF_5015     VARCHAR2(2048 BYTE),
    NM_FLD_2304         VARCHAR2(2048 BYTE), --concat SHRT_NM_2301 || NM_ROOT_RMDR_2517
    ID                  NUMBER(19),
    PRIMARY KEY(ID)
)
TABLESPACE IMRD_FTBL
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

--criando os sinonimos publicos
CREATE OR REPLACE PUBLIC SYNONYM EN_MRD_H6 FOR IMRD_F.EN_MRD_H6;

--criando indices
CREATE UNIQUE INDEX IDX_EN_MRD_H6_INC ON IMRD_F.EN_MRD_H6(NM_CD_2303) TABLESPACE IMRD_FTBL; 
-----------------------FIM----------------------
DROP TABLE IMRD_F.EN_MRD0107 CASCADE CONSTRAINTS;

--criando a tabela com a PK ID
CREATE TABLE IMRD_F.EN_MRD0107
(
    KEYWRD_GRP_CD_2034            VARCHAR2(2048 BYTE),
    KEYWRD_MOD_ST_2033            VARCHAR2(2048 BYTE),
    MODE_CD_4735                  VARCHAR2(2048 BYTE),
    MRC_3445                      VARCHAR2(2048 BYTE),
    MRC_TBL_CT_0848               VARCHAR2(2048 BYTE),
    MRC_USG_DESI_0847             VARCHAR2(2048 BYTE),
    MRD_STATUS_CD_0816            VARCHAR2(2048 BYTE),
    PRT_SKLTN_CD_0368             VARCHAR2(2048 BYTE),
    RQMT_RPY_INST_2648            VARCHAR2(2048 BYTE),
    RQMT_STMT_3614                VARCHAR2(2048 BYTE),
    RQMT_STMT_DEF_5027            VARCHAR2(2048 BYTE),
    TAM_RESP_COD_TAB_0365_E_8254  VARCHAR2(2048 BYTE),
    ID                            NUMBER(19),
    PRIMARY KEY(ID)
)
TABLESPACE IMRD_FTBL
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

--criando os sinonimos publicos
CREATE OR REPLACE PUBLIC SYNONYM EN_MRD0107 FOR IMRD_F.EN_MRD0107;
--dropando a sequence
DROP SEQUENCE IMRD_F.SQ_EN_TABL0107;
--criando a sequence
CREATE SEQUENCE IMRD_F.SQ_EN_TABL0107
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 0
  NOCYCLE
  NOCACHE
  NOORDER;
  
--criando indices
CREATE UNIQUE INDEX IDX_EN_MRD0107_INC ON IMRD_F.EN_MRD0107(MRC_3445) TABLESPACE IMRD_FTBL;  

-----------------------FIM----------------------
DROP TABLE IMRD_F.EN_MRD06P1 CASCADE CONSTRAINTS;

--criando a tabela com a PK ID
CREATE TABLE IMRD_F.EN_MRD06P1
(
    INC_4080            VARCHAR2(2048 BYTE),
    FIIG_4065           VARCHAR2(2048 BYTE),
    MRC_3445            VARCHAR2(2048 BYTE),
    RPLY_TBL_DCOD_3845  VARCHAR2(2048 BYTE),
    ID                  NUMBER(19),
    PRIMARY KEY(ID)
)
TABLESPACE IMRD_FTBL
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

--criando os sinonimos publicos
CREATE OR REPLACE PUBLIC SYNONYM EN_MRD06P1 FOR IMRD_F.EN_MRD06P1;

--dropando a sequence
DROP SEQUENCE IMRD_F.SQ_EN_TABL06P1;
--criando a sequence
CREATE SEQUENCE IMRD_F.SQ_EN_TABL06P1
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 0
  NOCYCLE
  NOCACHE
  NOORDER;

--criando indices
CREATE UNIQUE INDEX IDX_EN_MRD06P1_FIIG_INC_MRC ON IMRD_F.EN_MRD06P1(FIIG_4065, INC_4080, MRC_3445) TABLESPACE IMRD_FTBL;

-----------------------FIM----------------------
DROP TABLE IMRD_F.EN_MRD06P2 CASCADE CONSTRAINTS;

--criando a tabela com a PK ID
CREATE TABLE IMRD_F.EN_MRD06P2
(
    RPLY_TBL_DCOD_3845     VARCHAR2(2048 BYTE),
    SEC_AD_IND_CD_9485     VARCHAR2(2048 BYTE),
    SAC_8990               VARCHAR2(2048 BYTE),
    DCOD_ISAC_RPY_2308     VARCHAR2(2048 BYTE),
    ID                     NUMBER(19),
    PRIMARY KEY(ID)
)
TABLESPACE IMRD_FTBL
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

--criando os sinonimos publicos
CREATE OR REPLACE PUBLIC SYNONYM EN_MRD06P2 FOR IMRD_F.EN_MRD06P2;

--dropando a sequence
DROP SEQUENCE IMRD_F.SQ_EN_TABL06P2;
--criando a sequence
CREATE SEQUENCE IMRD_F.SQ_EN_TABL06P2
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 0
  NOCYCLE
  NOCACHE
  NOORDER;

--criando indices
CREATE UNIQUE INDEX IDX_EN_MRD06P2_RPLY_SAC ON IMRD_F.EN_MRD06P2(RPLY_TBL_DCOD_3845, SAC_8990) TABLESPACE IMRD_FTBL;

-----------------------FIM----------------------
DROP TABLE IMRD_F.EN_MRD076_H2_CLASSE CASCADE CONSTRAINTS;

--criando a tabela com a PK ID
CREATE TABLE IMRD_F.EN_MRD076_H2_CLASSE
(
    FSG_3994              VARCHAR2(2048 BYTE),
    FSC_WI_FSG_3996       VARCHAR2(2048 BYTE),
    STA_CD_NM_FSC_0320    VARCHAR2(2048 BYTE),
    FSC_INCL_NAR_0375     VARCHAR2(2048 BYTE),
    FSC_EXCL_NAR_0376     VARCHAR2(2048 BYTE),
    FSC_NOTE_4962         VARCHAR2(2048 BYTE),
    FSC_TI_4970           VARCHAR2(2048 BYTE),
    FSC_DT_E_C_RC_5182    VARCHAR2(2048 BYTE),
    ID                    NUMBER(19),
    PRIMARY KEY(ID)
)
TABLESPACE IMRD_FTBL
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

--criando os sinonimos publicos
CREATE OR REPLACE PUBLIC SYNONYM EN_MRD076_H2_CLASSE FOR IMRD_F.EN_MRD076_H2_CLASSE;

--dropando a sequence
DROP SEQUENCE IMRD_F.SQ_EN_TABL076;
--criando a sequence
CREATE SEQUENCE IMRD_F.SQ_EN_TABL076
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 0
  NOCYCLE
  NOCACHE
  NOORDER;

--criando indices
CREATE UNIQUE INDEX IDX_EN_MRD076_H2_FSG_FSC ON IMRD_F.EN_MRD076_H2_CLASSE(FSG_3994, FSC_WI_FSG_3996) TABLESPACE IMRD_FTBL;

-----------------------FIM----------------------
DROP TABLE IMRD_F.EN_MRD099_INC_CLASSE CASCADE CONSTRAINTS;

--criando a tabela com a PK ID
CREATE TABLE IMRD_F.EN_MRD099_INC_CLASSE
(
    NM_CD_2303          VARCHAR2(2048 BYTE),
    FSG_3994            VARCHAR2(2048 BYTE),
    FSC_WI_FSG_3996     VARCHAR2(2048 BYTE),
    DT_ESTB_CANC_0308   VARCHAR2(2048 BYTE),
    EFF_DT_2128         VARCHAR2(2048 BYTE),
    CL_ASST_MODH2_9554  VARCHAR2(2048 BYTE),
    ID                  NUMBER(19),
    PRIMARY KEY(ID)
)
TABLESPACE IMRD_FTBL
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

--criando os sinonimos publicos
CREATE OR REPLACE PUBLIC SYNONYM EN_MRD099_INC_CLASSE FOR IMRD_F.EN_MRD099_INC_CLASSE;


--dropando a sequence
DROP SEQUENCE IMRD_F.SQ_EN_TABL099;
--criando a sequence
CREATE SEQUENCE IMRD_F.SQ_EN_TABL099
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 0
  NOCYCLE
  NOCACHE
  NOORDER;

--criando indices
CREATE UNIQUE INDEX IDX_EN_MRD099_INC_FSG_FSC ON IMRD_F.EN_MRD099_INC_CLASSE(NM_CD_2303, FSG_3994, FSC_WI_FSG_3996) TABLESPACE IMRD_FTBL;

-----------------------FIM----------------------
DROP TABLE IMRD_F.EN_MRD0300 CASCADE CONSTRAINTS;

--criando a tabela com a PK ID
CREATE TABLE IMRD_F.EN_MRD0300
(
    RPLY_TBL_MRD_8254     VARCHAR2(2048 BYTE),
    CDD_RPLY_3465         VARCHAR2(2048 BYTE),
    RPLY_STAT_IND_2498    VARCHAR2(2048 BYTE),
    DCOD_RPLY_ST_3864     VARCHAR2(2048 BYTE),
    ID                    NUMBER(19),
    PRIMARY KEY(ID)
)
TABLESPACE IMRD_FTBL
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

--criando os sinonimos publicos
CREATE OR REPLACE PUBLIC SYNONYM EN_MRD0300 FOR IMRD_F.EN_MRD0300;

--dropando a sequence
DROP SEQUENCE IMRD_F.SQ_EN_TABL300;
--criando a sequence
CREATE SEQUENCE IMRD_F.SQ_EN_TABL300
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 0
  NOCYCLE
  NOCACHE
  NOORDER;

--criando indices
CREATE UNIQUE INDEX IDX_EN_MRD0300_RPLY_CDD ON IMRD_F.EN_MRD0300(RPLY_TBL_MRD_8254, CDD_RPLY_3465) TABLESPACE IMRD_FTBL;

-----------------------FIM----------------------
DROP TABLE IMRD_F.EN_MRD0500 CASCADE CONSTRAINTS;

--criando a tabela com a PK ID
CREATE TABLE IMRD_F.EN_MRD0500
(
    INC_4080               VARCHAR2(5 BYTE),
    FIIG_4065              VARCHAR2(2048 BYTE),
    MRC_3445               VARCHAR2(2048 BYTE),
    PHYS_DWG_ID_5037       VARCHAR2(8 BYTE),
    DCOD_STYL_RPY_2309     VARCHAR2(2048 BYTE),
    STYL_NBR_FIIG_0768     VARCHAR2(2048 BYTE),
    ID                     NUMBER(19),
    PRIMARY KEY(ID)
)
TABLESPACE IMRD_FTBL
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

--criando os sinonimos publicos
CREATE OR REPLACE PUBLIC SYNONYM EN_MRD0500 FOR IMRD_F.EN_MRD0500;

--dropando a sequence
DROP SEQUENCE IMRD_F.SQ_EN_TABL500;
--criando a sequence
CREATE SEQUENCE IMRD_F.SQ_EN_TABL500
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 0
  NOCYCLE
  NOCACHE
  NOORDER;

--criando indices
CREATE UNIQUE INDEX IDX_EN_MRD0500_FIIG_MRC_STYL ON IMRD_F.EN_MRD0500(FIIG_4065, MRC_3445, STYL_NBR_FIIG_0768) TABLESPACE IMRD_FTBL;

-----------------------FIM----------------------
DROP TABLE IMRD_F.EN_MRD120 CASCADE CONSTRAINTS;
--criando a tabela com a PK ID
CREATE TABLE IMRD_F.EN_MRD120
(
    FIIG_4065           VARCHAR2(2048 BYTE),
    INC_4080            VARCHAR2(2048 BYTE),
    MRC_3445            VARCHAR2(2048 BYTE),
    SAC_CDNG_IND_0115   VARCHAR2(2048 BYTE),
    DIML_MRC_IND_0326   VARCHAR2(2048 BYTE),
    PRPTN_EDIT_CD_0762  VARCHAR2(2048 BYTE),
    ISAC_IND_CD_0826    VARCHAR2(2048 BYTE),
    SCR_KEY_CD_1047     VARCHAR2(2048 BYTE),
    RPLY_TBL_DCOD_3845  VARCHAR2(2048 BYTE),
    TAIL_SEQ_NO_4403    VARCHAR2(2048 BYTE),
    FIIG_SEQ_NO_4404    VARCHAR2(2048 BYTE),
    MRC_IND_CD_8450     VARCHAR2(2048 BYTE),
    ID                  NUMBER(19),
    --CAR_ITEM_ID         NUMBER(38), -- vrf se tem necessiade no servcat?
    --ARTIGO_ID           NUMBER(38)  -- vrf se tem necessiade no servcat?
    PRIMARY KEY(ID)
)
TABLESPACE IMRD_FTBL
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

--criando os sinonimos publicos
CREATE OR REPLACE PUBLIC SYNONYM EN_MRD120 FOR IMRD_F.EN_MRD120;

--dropando a sequence
DROP SEQUENCE IMRD_F.SQ_EN_TABL0120;
--criando a sequence
CREATE SEQUENCE IMRD_F.SQ_EN_TABL0120
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 0
  NOCYCLE
  NOCACHE
  NOORDER;

--criando indices
CREATE UNIQUE  INDEX IDX_EN_MRD120_MRC_INC ON IMRD_F.EN_MRD120(MRC_3445, INC_4080) TABLESPACE IMRD_FTBL;
CREATE UNIQUE  INDEX IDX_EN_MRD120_MRC_INC_FIIG ON IMRD_F.EN_MRD120(MRC_3445, INC_4080, FIIG_4065) TABLESPACE IMRD_FTBL;

-----------------------FIM----------------------
DROP TABLE IMRD_F.EN_MRD316_H2_GRUPO CASCADE CONSTRAINTS;
--criando a tabela com a PK ID
CREATE TABLE IMRD_F.EN_MRD316_H2_GRUPO
(
    FSG_3994            VARCHAR2(2048 BYTE),
    STA_CD_NM_FSC_0320  VARCHAR2(2048 BYTE),
    FSG_NOTE_4965       VARCHAR2(2048 BYTE),
    FSG_TI_4972         VARCHAR2(2048 BYTE),
    FSG_DT_E_C_RC_5183  VARCHAR2(2048 BYTE),
    ID                  NUMBER(19)                NOT NULL,
    PRIMARY KEY(ID)
)
TABLESPACE IMRD_FTBL
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

--criando os sinonimos publicos
CREATE OR REPLACE PUBLIC SYNONYM EN_MRD316_H2_GRUPO FOR IMRD_F.EN_MRD316_H2_GRUPO;

--dropando a sequence
DROP SEQUENCE IMRD_F.SQ_EN_TABL316;
--criando a sequence
CREATE SEQUENCE IMRD_F.SQ_EN_TABL316
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 0
  NOCYCLE
  NOCACHE
  NOORDER;

--criando indices
CREATE UNIQUE  INDEX IDX_EN_MRD316_H2_GRUPO_FSG ON IMRD_F.EN_MRD316_H2_GRUPO(FSG_3994) TABLESPACE IMRD_FTBL;
-----------------------FIM----------------------